#!/usr/bin/perl

use DBI;
use Carp;

my $dbname = 'absence';
my $dbuser = 'absence';
my $dbpass = 'absence';

my $DBH = DBI->connect("dbi:Pg:dbname=$dbname", $dbuser, $dbpass, {AutoCommit => 1});
defined($DBH) || die "connection failed";

my $field = shift;
my $pid = shift;

#my $sql = qq{INSERT INTO $table ($keys) VALUES ($vals);};
my $sql = qq{SELECT $field FROM v_object WHERE id = $pid;};
print "SQL> $sql\n";

#$rv = $DBH->do($sql);
#defined($rv) || print "statement failed\n";

my $res = dbSelect($sql);
if (defined($res)) {
	print "result defined.\n";
} else {
	print "result undefined.\n";
}

$DBH->disconnect;

sub dbSelect
{
    my $sql = shift;

    my $sth;
    eval {
        $sth = $DBH->prepare($sql);
    };
    if ($@) {
        confess $@;
    }

    $sth->execute || confess "statement [$sql] failed";
 
    my @result;      
    my $ref;
    while(defined($ref = $sth->fetchrow_hashref)) {
        push(@result, $ref);
    }   
 
    if (wantarray) {
        return @result;
    } else {
        @result || return undef;
        return $result[0];
    }
}    

